
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>前端安全 / 憋错料</title>

    <meta name="description" content="前端安全 前端安全问题主要有XSS.CSRF攻击XSS:跨站脚本攻击它允许用户将恶意代码植入到提供给其他用户使用的页面中,可以简单的理解为一种javascript代码注入.XSS的防御措施: 过滤转义输入输出 避免使用eval.new Function等执行字符串的方法,除非确定字符串和用户输入无关 使用cookie的httpOnly属性,加上了这个属性的cookie字段,js是无法进行读写的 使用innerHTML.document.write的时候,如果数据是用户输入的,那么需要对象关键字符进行过滤与">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">前端安全</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>前端安全问题主要有XSS、CSRF攻击<br /><strong>XSS：跨站脚本攻击</strong><br />它允许用户将恶意代码植入到提供给其他用户使用的页面中，可以简单的理解为一种javascript代码注入。<br />XSS的防御措施：</p>
<ol>
<li>过滤转义输入输出</li>
<li>避免使用<code>eval</code>、<code>new Function</code>等执行字符串的方法，除非确定字符串和用户输入无关</li>
<li>使用cookie的httpOnly属性，加上了这个属性的cookie字段，js是无法进行读写的</li>
<li>使用innerHTML、document.write的时候，如果数据是用户输入的，那么需要对象关键字符进行过滤与转义</li>
</ol>
<p><strong>CRSF：跨站请求伪造</strong><br />其实就是网站中的一些提交行为，被黑客利用，在你访问黑客的网站的时候进行操作，会被操作到其他网站上<br />CRSF防御措施：</p>
<ol>
<li>检测http referer是否是同域名</li>
<li>避免登录的session长时间存储在客户端中</li>
<li>关键请求使用验证码或者token机制</li>
</ol>
<p>其他的一些攻击方法还有HTTP劫持、界面操作劫持</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 17:10:36 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e5%85%81%e8%ae%b8/" title="允许">允许</a>, <a href="https://www.biecuoliao.com/tag/str/" title="str">str</a>, <a href="https://www.biecuoliao.com/tag/class/" title="class">class</a>, <a href="https://www.biecuoliao.com/tag/fun/" title="fun">fun</a>, <a href="https://www.biecuoliao.com/tag/strong/" title="strong">strong</a>, <a href="https://www.biecuoliao.com/tag/%e5%b1%9e%e6%80%a7/" title="属性">属性</a>, <a href="https://www.biecuoliao.com/tag/%e5%88%a9%e7%94%a8/" title="利用">利用</a>, <a href="https://www.biecuoliao.com/tag/func/" title="func">func</a>, <a href="https://www.biecuoliao.com/tag/%e5%89%8d%e7%ab%af/" title="前端">前端</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>前端安全的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/B0Rwq3k.html" rel="bookmark">前端自动化之webstrom</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在刚接触前端的时候,使用的就一直是webstrom,版本是webstrom 8. 前端自动画使用的时候,因为webstrom 8版本是没有集成gulp的.所以每次使用都默默跑到Hbuild中使用. 实际最近在webstrom 12中找到了简单的方法,就连cmd都省了. 上图: 在gulp的gulpfile.js文件上右击,点击Show Gulp Tasks 会弹出gulp的控制窗口: 然后右键服务,点击run即可.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/gMWdB09.html" rel="bookmark">Day12 前端html</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前端基础之HTML 老师博客: http://www.cnblogs.com/yuanchenqi/articles/6835654.html http://www.cnblogs.com/yuanchenqi/articles/6856399.html html:静态的内容都是一个html标签,是有一组组标签构成的文件 css:对一个个标签做渲染定位 js:所有页面的动态效果做渲染定位 当写一个简单服务端的时候,一般这样写: 主要的是这:conn.send=(&quot;HTTP/1.1 201 OK			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/XMmzK0b.html" rel="bookmark">前端里移动端到底比pc端多哪些知识&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前端里移动端到底比pc端多哪些知识,为啥面试时好多公司都问h5水平如何? 我做过几年的web前端开发,就简单谈谈自己的感受吧. 首先来看看PC端和移动端在前端开发上的一些区别: (1)PC考虑的是浏览器兼容性,移动端开发考虑的更多的是手机兼容性,因为目前不管是android手机还是ios手机,一般浏览器用的都是webkit内核,所以做移动端开发,更多考虑的应该是手机分辨率的适配,和不同操作系统的略微差异化: (2)在部分事件的处理上,移动端自然是偏向于触屏的,所以触屏事件的一些规律要多摸索一下,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/VMGrA4z.html" rel="bookmark">一张图掌握移动Web前端所有技术（大前端、工程化、预编译、自动化）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				你要的移动web前端都在这里! 大前端方向:移动Web前端.Native客户端.Node.js. 大前端框架:React.Vue.js.Koa 跨终端技术:HTML 5.CSS 3.JavaScript 跨平台框架:React Native.Cordova 前端工程化:Grunt.Gulp.Webpack 前端预编译:Babel.Sass.Less 自动化测试:Jasmine.Mocha.Karma 一图在手,应有尽有! 更多信息参考:https://item.jd.com/12170351.h			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n4A8D3N.html" rel="bookmark">C&num;开发微信门户及应用&lpar;47&rpar; - 整合Web API、微信后台管理及前端微信小程序的应用方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在微信开发中,我一直强调需要建立一个比较统一的Web API接口体系,以便实现数据的集中化,这样我们在常规的Web业务系统,Winform业务系统.微信应用.微信小程序.APP等方面,都可以直接调用基于JSON数据格式的Web API接口,在我之前的几篇随笔中,对这方面都有一定的介绍,本篇继续这个主题,细致深入的阐述如何在接口和源码的基础上整合Web API.微信后台管理及前端微信小程序的应用方案. 1.基于Web API的微信开发框架 首先我们各个业务模块,都应该围绕着Web API进行展开,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/VMGKYMz.html" rel="bookmark">前端页面适配的rem换算</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为什么要使用rem 之前有些适配做法,是通过js动态计算viewport的缩放值(initial-scale). 例如以屏幕320像素为基准,设置1,那屏幕375像素就是375/320=1.18以此类推. 但直接这样强制页面缩放过于粗暴,会导致页面图片文字失真模糊. Px是相对固定单位,字号大小直接被定死,所以用户无法根据自己设置的浏览器字号而缩放,em和rem虽然都是相对单位,但em是相对于它的父元素的font-size,页面层级越深,em的换算就越复杂,而rem是直接相对于根元素,这就避开了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/v0knRlM.html" rel="bookmark">一个前端所需具备的PS能力</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前端网页设计+静态实现案例 放一个2天半内给某公司完成的(设计 + 静态实现)的案例吧,静态阴影用CSS3实现的http://www.cnblogs.com/MuYunyun/p/5693615.html,我最开始设计的时候就想好要用什么实现,各个框的大小是多少(精确到1像素),以及颜色搭配等等. 还有很多素材我就不演示了,设计了好些网页模板,如果有大家想用PS进行网页制作,欢迎大家交流. 很多人做前端只是掌握了最基本的切图(甚至连切图都有不会的),就连小小改动都要麻烦设计师,这就大大浪费了时间			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/9MBAAK4.html" rel="bookmark">分享第二届中国前端开发者大会与会心得</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第二届中国前端开发者大会(FDCon2017)是在上海举办的针对前端技术(HTML5,CSS,JS)的互联网开发者所举办的最盛大和权威的相关技术会议,由技术社区TopGeek主办.汇智Tek联合主办,致力于推动各类前端技术等在移动互联网领域的研发和应用. 随着新一代的前端技术的发展,给前端开发者带来巨大的创新应用实践机会,本大会以“高效前端开发实践和创新”为主题,内容涵盖电商.旅游.门户.搜索.分类广告.移动互联网等多种业态的技术经验分享,涉及各种WEB和APP前端开发技术和架构设计等方法论.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/yMXdQGM.html" rel="bookmark">前端开发四</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				7.闭包问题 闭包:函数能被外部调用到,则该作用连上的所有变量都会被保存下来. 作用:①可以读取函数内部的变量:②相当于划出了一块私有作用域,避免数据污染:③让变量始终保存在内存中 使用全局变量被认为是不好的习惯,而且容易造成错误并且维护成本较高,所以js可以采用闭包的方式读取函数的内部变量.但是如果大量使用闭包就会造成过多的变量始终保存在内存中,会造成内存泄漏. 一个简单的闭包例子: function f1(){ var n=999; function f2(){ alert(n); } re			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/r4Jk8VM.html" rel="bookmark">大公司里开发部署前端代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:张云龙链接:https://www.zhihu.com/question/20790576/answer/32602154来源:知乎著作权归作者所有,转载请联系作者获得授权. 前百度工程师,曾负责百度 前端集成解决方案 的核心设计与开发工作.我现在称这个领域为[前端工程].没错,这是我最爱唠叨的问题域. 这是一个非常有趣的 非主流前端领域,这个领域要探索的是如何用工程手段解决前端开发和部署优化的综合问题,入行到现在一直在学习和实践中. 在我的印象中,facebook是这个领域的鼻祖,有兴趣			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0ez1a3.html" rel="bookmark" class="title">Titanium系列－－利用js动态获取当前时间</a>
					<div>
						动态获取时间: //显示时间 function getDateTime() { var now = new Date(); var year = now.getFullYear(); var mont ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g41L9J3.html" rel="bookmark" class="title">Java实战之02Hibernate-05检索策略、检索方式</a>
					<div>
						十一.Hibernate的检索策略 1.概述: 查询的时机:什么时候去查? 1 /** 2 * 一张表的检索策略我们称之为: 3 * 类级别的检索策略. 4 * 注意:只要是说类级别的检索策略,就一定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dgxVeM.html" rel="bookmark" class="title">css001 Css需要的html</a>
					<div>
						Css需要的html 可以忘却的html属性和标签 1.不要用&lt;font&gt;来控制字体的大小和类型.(那要用什么?见第六章) 2.不要用&lt;b&gt;和&lt;i&gt;(b和i只是把字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kDZYd3.html" rel="bookmark" class="title">&lbrack;Codevs 1421&rsqb;秋静叶&amp;amp&semi;秋穣子&lpar;最大-最小博弈）</a>
					<div>
						题目:http://codevs.cn/problem/1421/ 分析:有向树上的最大-最小博弈 先手与后手的策略不同: 先手A:让对方取得尽量少的前提下,自己取得尽量大 后手B:让自己取得尽量多的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49oL6n0.html" rel="bookmark" class="title">第九章，测试系统</a>
					<div>
						在系统测试中,我们的目的就是:确保系统能够做顾客想要做的事.为了理解怎样实现这个目标,我们首先必须理解系统的错误来自那里. 在测试系统中有以下几步: 1． 功能测试 2． 执行测试 3． 协议测试 4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M61vRG4.html" rel="bookmark" class="title">Oracle 11g SQL fundamentals  03 -- 日期操作函数</a>
					<div>
						1.Oracle日期在内部的表示是数值格式,精确度从世纪到秒. 2.默认的日期表示格式为DD-MON-RR  (不是YY) YY 与 RR 的区别: 3.日期操作函数 示例: NEXT_DAY的第二个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myj22m0.html" rel="bookmark" class="title">ruby require</a>
					<div>
						require一般用来加载其它的类,如: #Ruby代码  :require 'dbi'  require &quot;rexml/document&quot; 但是上面加载的是标准类库里面的文件,当 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wyVaZM.html" rel="bookmark" class="title">js使用经验之谈</a>
					<div>
						1.  js 对象,先有的起作用.CSS属性,后有的起作用. 2. 方法中使用submit提交表单,如果提交后面还有代码需要执行,不能保证顺序.例如,提交后关闭页面,很可能会在提交前关闭页面,导致提交 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KqLNr4.html" rel="bookmark" class="title">UVA 825 --Walking on the Safe Side&plus;DP</a>
					<div>
						从一个点开始,如果始终只往右边和下边走,则如果能到达右下角距离必定是最小的, 且无论走那条路线距离都是一样的. 代码如下: &lt;span style=&quot;font-size:18px;&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6bRDXM.html" rel="bookmark" class="title">四、处理项目中的资源文件：es6、css、图片压缩、图片转成base64的编码形式</a>
					<div>
						新建目录 Coponents : 放需要的应用组件,创建layer组件: --App.js : 应用的入口 --创建layer组件: Layer.html Layer.less Layer.js -- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWEnP4.html" rel="bookmark" class="title">Vim编辑器 Visual Interface iMproved 全屏编辑器</a>
					<div>
						Vim模式: 1.命令模式(编辑模式) 2.输入模式 3.末行模式 模式转换 编辑模式--&gt;输入模式 i:在当前光标所在字符的前面插入字符 a:在当前光标所在字符的后面插入字符 o: 在当前光标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lWlwZM.html" rel="bookmark" class="title">团队项目：第七关攻略</a>
					<div>
						第七关 第七关是前面几关的综合,需要利用开关门消除后方平台. 如图画一个大圈即可到达终点					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPwdZn4.html" rel="bookmark" class="title">oracle中utl&lowbar;file包读写文件操作实例学习</a>
					<div>
						在oracle中utl_file包提供了一些操作文本文件的函数和过程,学习了一下他的基本操作 1.创建directory,并给用户授权 复制代码 代码如下: --创建directory create  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KZeaOM.html" rel="bookmark" class="title">python&mdash;&mdash;tuple元组</a>
					<div>
						&gt;&gt;&gt; dir(tuple) ['__add__', '__class__', '__contains__', '__delattr__', '__doc__', '__eq__', ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZ9PB4.html" rel="bookmark" class="title">树套树【bzoj3262】陌上花开</a>
					<div>
						/* [bzoj3262]陌上花开 2014年6月19日1,2430 Description 有n朵花,每朵花有三个属性:花形(s).颜色(c).气味(m),又三个整数表示.现要对每朵花评级,一朵花的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGAkgV3.html" rel="bookmark" class="title">带进度条的Webview</a>
					<div>
						转帖: http://droidyue.com/blog/2014/07/12/ding-bu-dai-jin-du-tiao-de-webview/ 写这篇文章,做份备忘,简单滴展示一个带进度条的W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyNjlY0.html" rel="bookmark" class="title">2016年9月6日 星期二 --出埃及记 Exodus 17&colon;2</a>
					<div>
						So they quarreled with Moses and said, &quot;Give us water to drink.&quot; Moses replied, &quot;Why  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xXwDQ0.html" rel="bookmark" class="title">磨刀：mac 上简洁搭建ejabberd 环境</a>
					<div>
						和app-get,或者yum类似, 这里使用的是mac上的软件管理工具port. 先磨刀,安装port的方法呢? 访问如下网站: https://www.macports.org/install.ph ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6ewoN4.html" rel="bookmark" class="title">struts&lpar;配置文件&rpar;</a>
					<div>
						1. 在Struts2中默认为转发,也就是&lt;result&gt;标签中的type=&quot;dispatcher&quot;,type的属性可以修改为重定向Struts的重定向有两种: typ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rpBmaM.html" rel="bookmark" class="title">11g adg 环境搭建实施手册-0824</a>
					<div>
						2017年8月24日 10:18 ################################################################ 简介 从11g 开始oracle提供 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
